function Img=util_Img_X(X, Nx)
%% Makes an image for visualization out of a list of symbols.
% function Img=util_Img_X(X, Nx)
% Input: 
%   X:  Discrete symbols.
%   Nx: Vocabulary size (assumed has integer squareroot).
% Output:
%   Img: Image suitable for display.

nx = round(sqrt(Nx));
Img = zeros(nx,nx);
for n = 1 : numel(X)
    Img(X(n))=Img(X(n))+1;
end