function [X,Y]=util_sample_HMM2(Model, N)
%% function [X,Y]=sample_HMM2(Model, N)
% Sample [X,Y] from a HMM with the specified parameters.
% TODO: Remove reference to Minka's sample here and replace with my
% efficient version.
if(nargin < 2)
    N = 1;
end

Y = zeros(1,Model.T);
X = zeros(N,Model.T);
% Y(1) = discrete_sample_rejection(Model.psi0,1);
% X(:,1) = discrete_sample_rejection(Model.theta(:,Y(1)),N);
% for t = 2 : Model.T
%     Y(t) = discrete_sample_rejection(Model.psi(:,Y(t-1)),1);
%     X(:,t) = discrete_sample_rejection(Model.theta(:,Y(t)),N);
% end

Y(1) = randsample(Model.Nz,1,true,Model.psi0); %sample(Model.psi0,1);
X(:,1) = randsample(Model.Ny,N,true,Model.theta(:,Y(1))); %sample(Model.theta(:,Y(1)),N);
for t = 2 : Model.T
    Y(t) = randsample(Model.Nz,1,true,Model.psi(:,Y(t-1))); %sample(Model.psi(:,Y(t-1)),1);
    X(:,t) = randsample(Model.Ny,N,true,Model.theta(:,Y(t))); %sample(Model.theta(:,Y(t)),N);
end