function util_showImgClust(phi, theta, iter)
%% function util_showImgClust(phi, theta)
% Visualize p(Words|Cluster) structure.
[Ny, Nz, Ns, Nm] = size(theta);
if(nargin==2)
    iter = Ns;
end

k = 1;
for s = 1 : min(Nm,4)
    X_Z = phi(:,:,iter,s)*theta(:,:,iter,s); 
    for z = 1 : Nz
        subplot(Nm,Nz,k); imagesc(reshape(X_Z(:,z), [5,5])); 
        set(gca,'xticklabel',{}); set(gca,'yticklabel',{}); colormap gray;
        k=k+1;
    end
end

k=1;
for i = 1:Nz:Nm*Nz
    subplot(Nm, Nz, i); ylabel(sprintf('Chain %d',k));
    k=k+1;
end
for i = 1 : Nz
    subplot(Nm, Nz, i); title(sprintf('Words | Cluster %d',i));
end
