function util_showImgPSI(S)
%% function util_showImgPSI(S)
% Print graphical reprentation of a PHI parameter  p(Words|Topics) structure.


Nc = 4; Nr = 3;
%sfigure(4); clf; 
if(isstruct(S)) %It's a BM structure.
    k=1; Nm = numel(S);
    for i = 1 : min(3, Nm)
        for j = 1 : 4
            subplot(3, 4, k); 
            imagesc(reshape(S(i).phi_est(:,j), [5, 5]));  colormap gray;
            k=k+1;
        end
    end
else %It's an RR cell.
    k=1; Nm = size(S,4); Nz=size(S,1);
    Nc = Nm; Nr=1;
    for i = 1 : Nr
        for j = 1 : Nc
            subplot(Nc, Nc, k); 
            imagesc(reshape(mean(S(:,:,end,j), 3), [Nz, Nz])); colormap gray;
            k=k+1;
        end
    end    
end
% subplot(Nr, Nc, 5); ylabel('Models');
% subplot(Nr, Nc, 10); xlabel('Topics'); 
% subplot(Nr, Nc, 3); title('Word Dist Per Topic');